#include <Include\MenuCmd.au3>
#include <Include\IconLib.au3>
#include <Include\TCHelpers.au3>

#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>

;Global Const $sTreeXml     = @ScriptDir & "\menutree.xml"
;Global Const $sIconsSrcDir = @ScriptDir & "\Icons\"
;Global Const $sCommandsIni = @ScriptDir & "\commands.ini"
;Global Const $sBasePathStr = "%COMMANDER_PATH%\Scripts\"
;Global Const $sIconPathStr = "%COMMANDER_PATH%\Icons\"
;Global Const $sScriptPrefix = "em_script_"


Global Enum $IO_INI_FILE, $IO_INC_FILE, $IO_MNU_FILE, $IO_FTP_FILE, $IO_LNG_FILE, $IO_USERCMD_FILE, _
            $IO_SCRIPT_DIR, $IO_ICONS_DIR, _
            $IO_STR_SCRIPTS_BASE, $IO_STR_ICONS_BASE, $IO_STR_SCRIPT_PREFIX, _
            $IO_TEMP_CMD_INI, $IO_INTEGR_XMLTREE, $IO_INTEGR_ICONSRC, _
            $IO_MAX_ITEMS

Global $aOpts[$IO_MAX_ITEMS]

$aOpts[$IO_INTEGR_XMLTREE]    = @ScriptDir & "\menutree.xml"
$aOpts[$IO_INTEGR_ICONSRC]    = @ScriptDir & "\Icons\"
$aOpts[$IO_STR_SCRIPTS_BASE]  = "%COMMANDER_PATH%\Scripts\"
$aOpts[$IO_STR_ICONS_BASE]    = "%COMMANDER_PATH%\Icons\"
$aOpts[$IO_STR_SCRIPT_PREFIX] = "em_script_"
$aOpts[$IO_TEMP_CMD_INI]      = @ScriptDir & "\commands.ini"

Global $sIntegratorIni = @ScriptDir & "\integrator.ini"

#Region ### START Koda GUI section ### Form=integrator.kxf
$Form1 = GUICreate("Build release", 453, 364, -1, -1)
$cbCreateCommands = GUICtrlCreateCheckbox("Create TCCommands.au3", 8, 56, 153, 17)
$cbCreateIcons = GUICtrlCreateCheckbox("Create icon libraries", 8, 80, 129, 17)
$cbFixLang = GUICtrlCreateCheckbox("Fix language", 8, 104, 97, 17)
$cbCreateMenu = GUICtrlCreateCheckbox("Create main menu", 8, 128, 121, 17)
$cbClearSect = GUICtrlCreateCheckbox("Clear user ini sections", 8, 152, 129, 17)
$btnOK = GUICtrlCreateButton("OK", 288, 328, 75, 25)
$btnCancel = GUICtrlCreateButton("Cancel", 368, 328, 75, 25)
$List = GUICtrlCreateList("", 8, 184, 433, 97)
$ibWorkingCopy = GUICtrlCreateInput("", 8, 24, 433, 21)
$Label1 = GUICtrlCreateLabel("Working copy", 8, 4, 70, 17)
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

GUICtrlSetData($ibWorkingCopy, IniRead($sIntegratorIni, "Main", "TCPath", ""))

GUICtrlSetState($cbCreateCommands, IniRead($sIntegratorIni, "Actions", "CreateCommands", $GUI_UNCHECKED))
GUICtrlSetState($cbCreateIcons, IniRead($sIntegratorIni, "Actions", "CreateIcons", $GUI_UNCHECKED))
GUICtrlSetState($cbFixLang, IniRead($sIntegratorIni, "Actions", "FixLanguage", $GUI_UNCHECKED))
GUICtrlSetState($cbCreateMenu, IniRead($sIntegratorIni, "Actions", "CreateMenu", $GUI_CHECKED))
GUICtrlSetState($cbClearSect, IniRead($sIntegratorIni, "Actions", "ClearSections", $GUI_UNCHECKED))

Global $bNeedRestart = false


While 1
 $nMsg = GUIGetMsg()
 Switch $nMsg
  Case $GUI_EVENT_CLOSE, $btnCancel
   Exit
  Case $btnOK
    $sTCPath = GUICtrlRead($ibWorkingCopy)
    If StringRight($sTCPath, 1) = '\' Then $sTCPath = StringTrimRight($sTCPath, 1)
    If Not FileExists($sTCPath) Then
        MsgBox (0, "", "Total Commander path is not exists.")
        ContinueLoop
    EndIf
    If EnvGet("COMMANDER_PATH") = $sTCPath Then 
        $nAnswer = MsgBox (3, "", "You run build script from active copy. TC need to be closed before this opertation. Close and restart?")
        Switch $nAnswer
            Case 2
                ContinueLoop
            Case 6
                $bNeedRestart = True
                $hWnd =  _TCHGetActiveInstance()
                _TCHSendMessage($cm_ConfigSaveSettings, 0, $hWnd)
                WinClose($hWnd)
                WinWaitClose($hWnd)
        EndSwitch
    EndIf        

;    $sIniFile = $sTCPath & "\WINCMD.INI"
;    $sIncFile = $sTCPath & "\TOTALCMD.INC"
;    $sAu3CommandsInc = $sTCPath & "\Scripts\Include\TCCommands.au3"
;    $sLngFile = $sTCPath & "\Language\WCMD_RUS.LNG"
;    $sMnuFile = $sTCPath & "\Config\Wcmd_rus_ext.mnu"
;    $sUsercmdIni = $sTCPath & "\USERCMD.INI"
;    $sScriptsPath = $sTCPath & "\Scripts\"
;    $IconsPath = $sTCPath & "\Icons\"


    $aOpts[$IO_INI_FILE]     = $sTCPath & "\WINCMD.INI"
    $aOpts[$IO_INC_FILE]     = $sTCPath & "\TOTALCMD.INC"
    $aOpts[$IO_LNG_FILE]     = $sTCPath & "\Language\WCMD_RUS.LNG"
    $aOpts[$IO_FTP_FILE]     = $sTCPath & "\wcx_ftp.ini"
    $aOpts[$IO_MNU_FILE]     = $sTCPath & "\Config\Wcmd_rus_ext.mnu"
    $aOpts[$IO_USERCMD_FILE] = $sTCPath & "\USERCMD.INI"
    $aOpts[$IO_SCRIPT_DIR]   = $sTCPath & "\Scripts\"
    $aOpts[$IO_ICONS_DIR]    = $sTCPath & "\Icons\"

    ; important for working any functions that expand COMMANDER_PATH variable
    EnvSet("COMMANDER_PATH", $sTCPath)

    IniWrite($sIntegratorIni, "Main", "TCPath", $sTCPath)

    If BitAND(GUICtrlRead($cbCreateCommands), $GUI_CHECKED) Then GUICtrlSetData($List, _CreateCommandsInclude($aOpts))
    If BitAND(GUICtrlRead($cbFixLang), $GUI_CHECKED) Then GUICtrlSetData($List, _FixLanguage($aOpts))
    If BitAND(GUICtrlRead($cbCreateIcons), $GUI_CHECKED) Then GUICtrlSetData($List, _CreateIconLibraries($aOpts))
    If BitAND(GUICtrlRead($cbCreateMenu), $GUI_CHECKED) Then GUICtrlSetData($List, _CreateMenuCommandsHotkeys($aOpts))
    If BitAND(GUICtrlRead($cbClearSect), $GUI_CHECKED) Then GUICtrlSetData($List, _PrepareRelease($aOpts))

    If $bNeedRestart Then Run($sTCPath & "\totalcmd.exe")
    Exit
 EndSwitch
WEnd


Func _CreateMenuCommandsHotkeys(ByRef $aOpt)

    Local $oXml = ObjCreate("Msxml2.DOMDocument")
    $oXml.async=0
    $oXml.validateOnParse = false
    $oXml.resolveExternals = false
    $oXml.preserveWhiteSpace = true
    $oXml.Load($aOpt[$IO_INTEGR_XMLTREE])
    $oXml.setProperty("SelectionLanguage", "XPath")
    Local $oXmlRoot = $oXml.documentElement
    Local $oMenuRoot = $oXmlRoot.SelectSingleNode('menu')
    Local $oHintRoot = $oXmlRoot.SelectSingleNode('hints')

    FileDelete($aOpt[$IO_USERCMD_FILE])

    _CreateScripts($oMenuRoot, $aOpt)
    _CreateUserCommands($oMenuRoot, $aOpt)
    _CreateStdCommands($oMenuRoot, $aOpt)
    _CreateMenu($oMenuRoot, $aOpt)
    _CreateHints($oHintRoot, $aOpt)

    _WriteHotkeys($aOpt[$IO_INI_FILE])
    _WriteAliases($aOpt[$IO_INI_FILE])

    Return "Menu and other created."
EndFunc


Func _CreateHints($oHintRoot, $aOpt)
    Local $nCounter = 0
    _TCHIniClearSection($aOpt[$IO_INI_FILE], "HintsCustomField")
    $oNodes = $oHintRoot.selectNodes('hint')
    For $oNode In $oNodes
        $sType = $oNode.getAttribute('type')
        $sHint = StringStripWS($oNode.text, 3)
        $sHint = StringRegExpReplace($sHint, "\r\n|[\n\r]", "\\n")
        _TCHIniWrite($aOpt[$IO_INI_FILE], "HintsCustomField", $nCounter & "exts", $sType)
        _TCHIniWrite($aOpt[$IO_INI_FILE], "HintsCustomField", $nCounter & "fields", $sHint)
        $nCounter += 1
    Next    
EndFunc

Func _CreateCommandsInclude(ByRef $aOpt)
    Local $aSections = IniReadSectionNames($aOpt[$IO_INC_FILE])
    Local $hFile = FileOpen($aOpt[$IO_SCRIPT_DIR] & "Include\TCCommands.au3", 2)

    FileWriteLine($hFile, "#include-once")

    Local $gCount = 0
    IniDelete($aOpt[$IO_TEMP_CMD_INI], "Commands")
    For $i=1 To $aSections[0]
        if StringInStr($aSections[$i], "Commands with parameters") Then ContinueLoop
        $aSect = IniReadSection ($aOpt[$IO_INC_FILE], $aSections[$i])
        For $j=1 To $aSect[0][0]
            $gCount += 1
            FileWriteLine($hFile, StringFormat("Global Const $%s=%s", $aSect[$j][0], StringRegExpReplace($aSect[$j][1], ";.*$", "")))
            IniWrite($aOpt[$IO_TEMP_CMD_INI], "Commands", StringRegExpReplace($aSect[$j][1], ";.*$", ""), $aSect[$j][0])
        Next
    Next
    FileClose($hFile)
    Return "Imported " & $gCount & " commands from TOTALCMD.INC."
EndFunc

Func _FixLanguage(ByRef $aOpt)
    Local $bErr = false
    Local $sFile = FileRead($aOpt[$IO_LNG_FILE])

    $sFile = StringReplace($sFile, "<>", "<DIR>")
    If @extended = 0 Then $bErr = true
    $sFile = StringReplace($sFile, "<>", "<LNK>")
    If @extended = 0 Then $bErr = True
    
    If $bErr Then Return "Language strings was NOT replaced (maybe already done)."

    Local $hFile = FileOpen($aOpt[$IO_LNG_FILE], 2)
    FileWrite($hFile, $sFile)
    FileClose($hFile)

    Return "Language strings replaced sucsessfuly."
EndFunc

Func _PrepareRelease(ByRef $aOpt)
    _TCHIniClearSection($aOpt[$IO_INI_FILE], "SearchIn")
    _TCHIniClearSection($aOpt[$IO_INI_FILE], "SearchText")
    _TCHIniClearSection($aOpt[$IO_INI_FILE], "SearchName")
    _TCHIniClearSection($aOpt[$IO_INI_FILE], "RenameSearchFind")
    _TCHIniClearSection($aOpt[$IO_INI_FILE], "RenameSearchReplace")
    _TCHIniClearSection($aOpt[$IO_INI_FILE], "Command line history")
    _TCHIniClearSection($aOpt[$IO_INI_FILE], "RenameTemplates")
    _TCHIniClearSection($aOpt[$IO_INI_FILE], "Selection")
    _TCHIniClearSection($aOpt[$IO_INI_FILE], "rename")
    _TCHIniClearSection($aOpt[$IO_INI_FILE], "left")
    _TCHIniClearSection($aOpt[$IO_INI_FILE], "right")
    _TCHIniClearSection($aOpt[$IO_INI_FILE], "lefttabs")
    _TCHIniClearSection($aOpt[$IO_INI_FILE], "righttabs")

    _TCHIniWrite($aOpt[$IO_INI_FILE], "left", "sortorder", 1)
    _TCHIniWrite($aOpt[$IO_INI_FILE], "right", "sortorder", 1)

    _TCHIniClearSection($aOpt[$IO_FTP_FILE], "OldConnections")
    _TCHIniClearSection($aOpt[$IO_FTP_FILE], "firewall")
    IniDelete($aOpt[$IO_FTP_FILE], "General", "AESVerify")
    IniWrite($aOpt[$IO_FTP_FILE], "General", "e-mail", "mymail@mail.com")
    IniDelete($aOpt[$IO_FTP_FILE], "General", "AESVerify")
    IniWrite($aOpt[$IO_FTP_FILE], "firewall", "Method", 0)
    $aConn = IniReadSection($aOpt[$IO_FTP_FILE], "connections")
    If UBound($aConn) > 0 Then
        For $i=1 To $aConn[0][0]
            IniDelete($aOpt[$IO_FTP_FILE], $aConn[$i][1])
        Next
    EndIf
    _TCHIniClearSection($aOpt[$IO_FTP_FILE], "connections")
    Return "Configuration cleaned up."
EndFunc
